import { OnInit, TemplateRef } from '@angular/core';
export declare type AvatarColor = 'primary' | 'accent' | 'gradient' | 'initials';
export declare type DefaultGravatar = 'mp' | 'identicon' | 'monsterid' | 'wavatar' | 'retro' | 'robohash';
export declare class UxgImageAvatar {
}
export declare class AvatarComponent implements OnInit {
    name: string | undefined;
    gravatarEmail: string | undefined;
    defaultGravatar: DefaultGravatar | undefined;
    color: AvatarColor;
    get dense(): boolean;
    set dense(value: boolean);
    private _dense;
    avatarImage: TemplateRef<any> | null;
    _explicitContent: TemplateRef<any> | undefined;
    _implicitContent: TemplateRef<any>;
    avatarContent: TemplateRef<any>;
    paletteColor: number;
    gravatarUrl: string;
    constructor();
    getCode(str: string): number;
    generateGravatar(): void;
    ngOnInit(): void;
}
