import { OnDestroy, ChangeDetectorRef } from '@angular/core';
import { Breadcrumb } from './breadcrumb';
import { Router } from '@angular/router';
import { BreakpointObserver } from '@angular/cdk/layout';
export declare class UxgBreadcrumbComponent implements OnDestroy {
    dense: any;
    color: any;
    private router;
    private breakpointObserver;
    private cd;
    private breadcrumbs$;
    private _breadcrumbs;
    get breadcrumbs(): Breadcrumb[];
    set breadcrumbs(value: Breadcrumb[]);
    private _enableBackButton;
    get enableBackButton(): boolean;
    set enableBackButton(value: boolean);
    /**
     * Back button can be displayed only in mobile mode and if breadscrumb have more than two items.
     */
    shouldDisplayBackButton: boolean;
    private destroyed$;
    constructor(dense: any, color: any, router: Router, breakpointObserver: BreakpointObserver, cd: ChangeDetectorRef);
    ngOnDestroy(): void;
    backToPreviousPage(): void;
}
