(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/tooltip'), require('@angular/flex-layout'), require('@angular/material/input'), require('@angular/material/form-field'), require('@angular/material/select'), require('@ffdc/uxg-angular-components/core'), require('angular-plotly.js')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/vector-map', ['exports', '@angular/core', '@angular/common', '@angular/material/tooltip', '@angular/flex-layout', '@angular/material/input', '@angular/material/form-field', '@angular/material/select', '@ffdc/uxg-angular-components/core', 'angular-plotly.js'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['vector-map'] = {}), global.ng.core, global.ng.common, global.ng.material.tooltip, global.ng.flexLayout, global.ng.material.input, global.ng.material.formField, global.ng.material.select, global.ffdc['uxg-angular-components'].core, global.angularPlotly_js));
}(this, (function (exports, core, common, tooltip, flexLayout, input, formField, select, core$1, angularPlotly_js) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var COUNTRIES = [
        { name: 'Afghanistan', value: 0, code: 'AFG' },
        { name: 'Albania', value: 0, code: 'ALB' },
        { name: 'Algeria', value: 0, code: 'DZA' },
        { name: 'American Samoa', value: 0, code: 'ASM' },
        { name: 'Andorra', value: 0, code: 'AND' },
        { name: 'Angola', value: 0, code: 'AGO' },
        { name: 'Anguilla', value: 0, code: 'AIA' },
        { name: 'Antigua and Barbuda', value: 0, code: 'ATG' },
        { name: 'Argentina', value: 0, code: 'ARG' },
        { name: 'Armenia', value: 0, code: 'ARM' },
        { name: 'Aruba', value: 0, code: 'ABW' },
        { name: 'Australia', value: 0, code: 'AUS' },
        { name: 'Austria', value: 0, code: 'AUT' },
        { name: 'Azerbaijan', value: 0, code: 'AZE' },
        { name: 'Bahamas, The', value: 0, code: 'BHM' },
        { name: 'Bahrain', value: 0, code: 'BHR' },
        { name: 'Bangladesh', value: 0, code: 'BGD' },
        { name: 'Barbados', value: 0, code: 'BRB' },
        { name: 'Belarus', value: 0, code: 'BLR' },
        { name: 'Belgium', value: 0, code: 'BEL' },
        { name: 'Belize', value: 0, code: 'BLZ' },
        { name: 'Benin', value: 0, code: 'BEN' },
        { name: 'Bermuda', value: 0, code: 'BMU' },
        { name: 'Bhutan', value: 0, code: 'BTN' },
        { name: 'Bolivia', value: 0, code: 'BOL' },
        { name: 'Bosnia and Herzegovina', value: 0, code: 'BIH' },
        { name: 'Botswana', value: 0, code: 'BWA' },
        { name: 'Brazil', value: 0, code: 'BRA' },
        { name: 'British Virgin Islands', value: 0, code: 'VGB' },
        { name: 'Brunei', value: 0, code: 'BRN' },
        { name: 'Bulgaria', value: 0, code: 'BGR' },
        { name: 'Burkina Faso', value: 0, code: 'BFA' },
        { name: 'Burma', value: 0, code: 'MMR' },
        { name: 'Burundi', value: 0, code: 'BDI' },
        { name: 'Cabo Verde', value: 0, code: 'CPV' },
        { name: 'Cambodia', value: 0, code: 'KHM' },
        { name: 'Cameroon', value: 0, code: 'CMR' },
        { name: 'Canada', value: 0, code: 'CAN' },
        { name: 'Cayman Islands', value: 0, code: 'CYM' },
        { name: 'Central African Republic', value: 0, code: 'CAF' },
        { name: 'Chad', value: 0, code: 'TCD' },
        { name: 'Chile', value: 0, code: 'CHL' },
        { name: 'China', value: 0, code: 'CHN' },
        { name: 'Colombia', value: 0, code: 'COL' },
        { name: 'Comoros', value: 0, code: 'COM' },
        { name: 'Congo, Democratic Republic of the', value: 0, code: 'COD' },
        { name: 'Congo, Republic of the', value: 0, code: 'COG' },
        { name: 'Cook Islands', value: 0, code: 'COK' },
        { name: 'Costa Rica', value: 0, code: 'CRI' },
        { name: "Cote d'Ivoire", value: 0, code: 'CIV' },
        { name: 'Croatia', value: 0, code: 'HRV' },
        { name: 'Cuba', value: 0, code: 'CUB' },
        { name: 'Curacao', value: 0, code: 'CUW' },
        { name: 'Cyprus', value: 0, code: 'CYP' },
        { name: 'Czech Republic', value: 0, code: 'CZE' },
        { name: 'Denmark', value: 0, code: 'DNK' },
        { name: 'Djibouti', value: 0, code: 'DJI' },
        { name: 'Dominica', value: 0, code: 'DMA' },
        { name: 'Dominican Republic', value: 0, code: 'DOM' },
        { name: 'Ecuador', value: 0, code: 'ECU' },
        { name: 'Egypt', value: 0, code: 'EGY' },
        { name: 'El Salvador', value: 0, code: 'SLV' },
        { name: 'Equatorial Guinea', value: 0, code: 'GNQ' },
        { name: 'Eritrea', value: 0, code: 'ERI' },
        { name: 'Estonia', value: 0, code: 'EST' },
        { name: 'Ethiopia', value: 0, code: 'ETH' },
        { name: 'Falkland Islands (Islas Malvinas)', value: 0, code: 'FLK' },
        { name: 'Faroe Islands', value: 0, code: 'FRO' },
        { name: 'Fiji', value: 0, code: 'FJI' },
        { name: 'Finland', value: 0, code: 'FIN' },
        { name: 'France', value: 0, code: 'FRA' },
        { name: 'French Polynesia', value: 0, code: 'PYF' },
        { name: 'Gabon', value: 0, code: 'GAB' },
        { name: 'Gambia, The', value: 0, code: 'GMB' },
        { name: 'Georgia', value: 0, code: 'GEO' },
        { name: 'Germany', value: 0, code: 'DEU' },
        { name: 'Ghana', value: 0, code: 'GHA' },
        { name: 'Gibraltar', value: 0, code: 'GIB' },
        { name: 'Greece', value: 0, code: 'GRC' },
        { name: 'Greenland', value: 0, code: 'GRL' },
        { name: 'Grenada', value: 0, code: 'GRD' },
        { name: 'Guam', value: 0, code: 'GUM' },
        { name: 'Guatemala', value: 0, code: 'GTM' },
        { name: 'Guernsey', value: 0, code: 'GGY' },
        { name: 'Guinea-Bissau', value: 0, code: 'GNB' },
        { name: 'Guinea', value: 0, code: 'GIN' },
        { name: 'Guyana', value: 0, code: 'GUY' },
        { name: 'Haiti', value: 0, code: 'HTI' },
        { name: 'Honduras', value: 0, code: 'HND' },
        { name: 'Hong Kong', value: 0, code: 'HKG' },
        { name: 'Hungary', value: 0, code: 'HUN' },
        { name: 'Iceland', value: 0, code: 'ISL' },
        { name: 'India', value: 0, code: 'IND' },
        { name: 'Indonesia', value: 0, code: 'IDN' },
        { name: 'Iran', value: 0, code: 'IRN' },
        { name: 'Iraq', value: 0, code: 'IRQ' },
        { name: 'Ireland', value: 0, code: 'IRL' },
        { name: 'Isle of Man', value: 0, code: 'IMN' },
        { name: 'Israel', value: 0, code: 'ISR' },
        { name: 'Italy', value: 0, code: 'ITA' },
        { name: 'Jamaica', value: 0, code: 'JAM' },
        { name: 'Japan', value: 0, code: 'JPN' },
        { name: 'Jersey', value: 0, code: 'JEY' },
        { name: 'Jordan', value: 0, code: 'JOR' },
        { name: 'Kazakhstan', value: 0, code: 'KAZ' },
        { name: 'Kenya', value: 0, code: 'KEN' },
        { name: 'Kiribati', value: 0, code: 'KIR' },
        { name: 'Korea, North', value: 0, code: 'PRK' },
        { name: 'Korea, South', value: 0, code: 'KOR' },
        { name: 'Kosovo', value: 0, code: 'KSV' },
        { name: 'Kuwait', value: 0, code: 'KWT' },
        { name: 'Kyrgyzstan', value: 0, code: 'KGZ' },
        { name: 'Laos', value: 0, code: 'LAO' },
        { name: 'Latvia', value: 0, code: 'LVA' },
        { name: 'Lebanon', value: 0, code: 'LBN' },
        { name: 'Lesotho', value: 0, code: 'LSO' },
        { name: 'Liberia', value: 0, code: 'LBR' },
        { name: 'Libya', value: 0, code: 'LBY' },
        { name: 'Liechtenstein', value: 0, code: 'LIE' },
        { name: 'Lithuania', value: 0, code: 'LTU' },
        { name: 'Luxembourg', value: 0, code: 'LUX' },
        { name: 'Macau', value: 0, code: 'MAC' },
        { name: 'Macedonia', value: 0, code: 'MKD' },
        { name: 'Madagascar', value: 0, code: 'MDG' },
        { name: 'Malawi', value: 0, code: 'MWI' },
        { name: 'Malaysia', value: 0, code: 'MYS' },
        { name: 'Maldives', value: 0, code: 'MDV' },
        { name: 'Mali', value: 0, code: 'MLI' },
        { name: 'Malta', value: 0, code: 'MLT' },
        { name: 'Marshall Islands', value: 0, code: 'MHL' },
        { name: 'Mauritania', value: 0, code: 'MRT' },
        { name: 'Mauritius', value: 0, code: 'MUS' },
        { name: 'Mexico', value: 0, code: 'MEX' },
        { name: 'Micronesia, Federated States of', value: 0, code: 'FSM' },
        { name: 'Moldova', value: 0, code: 'MDA' },
        { name: 'Monaco', value: 0, code: 'MCO' },
        { name: 'Mongolia', value: 0, code: 'MNG' },
        { name: 'Montenegro', value: 0, code: 'MNE' },
        { name: 'Morocco', value: 0, code: 'MAR' },
        { name: 'Mozambique', value: 0, code: 'MOZ' },
        { name: 'Namibia', value: 0, code: 'NAM' },
        { name: 'Nepal', value: 0, code: 'NPL' },
        { name: 'Netherlands', value: 0, code: 'NLD' },
        { name: 'New Caledonia', value: 0, code: 'NCL' },
        { name: 'New Zealand', value: 0, code: 'NZL' },
        { name: 'Nicaragua', value: 0, code: 'NIC' },
        { name: 'Nigeria', value: 0, code: 'NGA' },
        { name: 'Niger', value: 0, code: 'NER' },
        { name: 'Niue', value: 0, code: 'NIU' },
        { name: 'Northern Mariana Islands', value: 0, code: 'MNP' },
        { name: 'Norway', value: 0, code: 'NOR' },
        { name: 'Oman', value: 0, code: 'OMN' },
        { name: 'Pakistan', value: 0, code: 'PAK' },
        { name: 'Palau', value: 0, code: 'PLW' },
        { name: 'Panama', value: 0, code: 'PAN' },
        { name: 'Papua New Guinea', value: 0, code: 'PNG' },
        { name: 'Paraguay', value: 0, code: 'PRY' },
        { name: 'Peru', value: 0, code: 'PER' },
        { name: 'Philippines', value: 0, code: 'PHL' },
        { name: 'Poland', value: 0, code: 'POL' },
        { name: 'Portugal', value: 0, code: 'PRT' },
        { name: 'Puerto Rico', value: 0, code: 'PRI' },
        { name: 'Qatar', value: 0, code: 'QAT' },
        { name: 'Romania', value: 0, code: 'ROU' },
        { name: 'Russia', value: 0, code: 'RUS' },
        { name: 'Rwanda', value: 0, code: 'RWA' },
        { name: 'Saint Kitts and Nevis', value: 0, code: 'KNA' },
        { name: 'Saint Lucia', value: 0, code: 'LCA' },
        { name: 'Saint Martin', value: 0, code: 'MAF' },
        { name: 'Saint Pierre and Miquelon', value: 0, code: 'SPM' },
        { name: 'Saint Vincent and the Grenadines', value: 0, code: 'VCT' },
        { name: 'Samoa', value: 0, code: 'WSM' },
        { name: 'San Marino', value: 0, code: 'SMR' },
        { name: 'Sao Tome and Principe', value: 0, code: 'STP' },
        { name: 'Saudi Arabia', value: 0, code: 'SAU' },
        { name: 'Senegal', value: 0, code: 'SEN' },
        { name: 'Serbia', value: 0, code: 'SRB' },
        { name: 'Seychelles', value: 0, code: 'SYC' },
        { name: 'Sierra Leone', value: 0, code: 'SLE' },
        { name: 'Singapore', value: 0, code: 'SGP' },
        { name: 'Sint Maarten', value: 0, code: 'SXM' },
        { name: 'Slovakia', value: 0, code: 'SVK' },
        { name: 'Slovenia', value: 0, code: 'SVN' },
        { name: 'Solomon Islands', value: 0, code: 'SLB' },
        { name: 'Somalia', value: 0, code: 'SOM' },
        { name: 'South Africa', value: 0, code: 'ZAF' },
        { name: 'South Sudan', value: 0, code: 'SSD' },
        { name: 'Spain', value: 0, code: 'ESP' },
        { name: 'Sri Lanka', value: 0, code: 'LKA' },
        { name: 'Sudan', value: 0, code: 'SDN' },
        { name: 'Suriname', value: 0, code: 'SUR' },
        { name: 'Swaziland', value: 0, code: 'SWZ' },
        { name: 'Sweden', value: 0, code: 'SWE' },
        { name: 'Switzerland', value: 0, code: 'CHE' },
        { name: 'Syria', value: 0, code: 'SYR' },
        { name: 'Taiwan', value: 0, code: 'TWN' },
        { name: 'Tajikistan', value: 0, code: 'TJK' },
        { name: 'Tanzania', value: 0, code: 'TZA' },
        { name: 'Thailand', value: 0, code: 'THA' },
        { name: 'Timor-Leste', value: 0, code: 'TLS' },
        { name: 'Togo', value: 0, code: 'TGO' },
        { name: 'Tonga', value: 0, code: 'TON' },
        { name: 'Trinidad and Tobago', value: 0, code: 'TTO' },
        { name: 'Tunisia', value: 0, code: 'TUN' },
        { name: 'Turkey', value: 0, code: 'TUR' },
        { name: 'Turkmenistan', value: 0, code: 'TKM' },
        { name: 'Tuvalu', value: 0, code: 'TUV' },
        { name: 'Uganda', value: 0, code: 'UGA' },
        { name: 'Ukraine', value: 0, code: 'UKR' },
        { name: 'United Arab Emirates', value: 0, code: 'ARE' },
        { name: 'United Kingdom', value: 0, code: 'GBR' },
        { name: 'United States', value: 0, code: 'USA' },
        { name: 'Uruguay', value: 0, code: 'URY' },
        { name: 'Uzbekistan', value: 0, code: 'UZB' },
        { name: 'Vanuatu', value: 0, code: 'VUT' },
        { name: 'Venezuela', value: 0, code: 'VEN' },
        { name: 'Vietnam', value: 0, code: 'VNM' },
        { name: 'Virgin Islands', value: 0, code: 'VGB' },
        { name: 'West Bank', value: 0, code: 'WBG' },
        { name: 'Yemen', value: 0, code: 'YEM' },
        { name: 'Zambia', value: 0, code: 'ZMB' },
        { name: 'Zimbabwe', value: 0, code: 'ZWE' }
    ];
    var DEFAULT_DATA = {
        type: 'choropleth',
        hoverinfo: 'none',
        autocolorscale: false,
        reversescale: true,
        marker: {
            line: {}
        },
        tick0: 0,
        zmin: 0,
        zmax: 1,
        showscale: false
    };
    var DEFAULT_LAYOUT = {
        autosize: true,
        geo: {
            showframe: false,
            showcoastlines: false,
            projection: {
                type: 'miller'
            },
            center: {
                lat: 25,
                lon: 0
            }
        },
        margin: {
            l: 0,
            r: 0,
            b: 0,
            t: 0,
            pad: 0
        }
    };
    var DEFAULT_CONFIG = {
        displayModeBar: false,
        responsive: true
    };
    var DEFAULT_STYLE = {
        position: 'relative',
        width: '100%',
        height: '100%'
    };

    var VectorMapComponent = /** @class */ (function () {
        function VectorMapComponent(paletteService, lazyLoadScriptService) {
            this.paletteService = paletteService;
            this.lazyLoadScriptService = lazyLoadScriptService;
            this.title = 'Vector Map';
            this.dataSource = [];
            this.showLegend = true;
            this.autoResize = true;
            // tslint:disable-next-line: no-output-native
            this.click = new core.EventEmitter();
            this.viewChange = new core.EventEmitter();
            this.countries = [];
            this.data = [];
            this.layout = {};
            this.config = {};
            this.style = {};
            this.paletteConfig = core$1.PALETTE_DEFAULT_CONFIG;
            this.legend = [];
            this.viewId = null;
            this.views = [];
            this.tooltipTop = '';
            this.tooltipLeft = '0px';
            this.max = 1;
            this.subscriptions = [];
            this.click = new core.EventEmitter();
            this.plotlyReady$ = lazyLoadScriptService.load('plotly.js', 'Plotly');
        }
        VectorMapComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.setView();
            this.setLayout();
            this.setConfig();
            this.setStyle();
            this.subscriptions.push(this.paletteService.paletteChange$.subscribe(function (config) {
                _this.paletteConfig = config;
                _this.setPlotData();
                if (_this.plot)
                    _this.refresh();
            }));
        };
        VectorMapComponent.prototype.ngOnChanges = function (_b) {
            var _this = this;
            var dataSource = _b.dataSource, showLegend = _b.showLegend;
            var refreshPlot = false;
            var timedOutRefreshPlot = false;
            if (dataSource && !dataSource.isFirstChange()) {
                this.setView();
                this.setLayout();
                this.setPlotData();
                if (this.showLegend)
                    timedOutRefreshPlot = true;
            }
            if (showLegend && !showLegend.isFirstChange() && showLegend.currentValue !== showLegend.previousValue) {
                timedOutRefreshPlot = true;
            }
            if (timedOutRefreshPlot) {
                // passing check for next pass in browser event loop / angular lifecycle
                // checks so that the legend is hidden / shown properly
                setTimeout(function () {
                    _this.refresh();
                });
                refreshPlot = false;
            }
            if (refreshPlot) {
                this.refresh();
            }
        };
        VectorMapComponent.prototype.ngOnDestroy = function () {
            this.subscriptions.forEach(function (subscription) { return subscription.unsubscribe(); });
        };
        VectorMapComponent.prototype.onWindowResize = function () {
            if (this.autoResize) {
                this.refresh();
            }
        };
        VectorMapComponent.prototype.refresh = function () {
            try {
                this.plot.revision++;
                this.plot.updatePlot();
            }
            catch (_a) {
                this.plot.revision--;
            }
        };
        VectorMapComponent.prototype.getLegendValue = function (value, max) {
            return Math.floor(parseFloat((1 - value).toString()) * max);
        };
        VectorMapComponent.prototype.getData = function () {
            return this.dataSource instanceof Array ? this.dataSource : this.viewId ? this.dataSource.data[this.viewId] : [];
        };
        VectorMapComponent.prototype.setLayout = function (layout) {
            if (layout === void 0) { layout = {}; }
            this.layout = Object.assign(Object.assign({}, DEFAULT_LAYOUT), layout);
        };
        VectorMapComponent.prototype.setConfig = function (config) {
            if (config === void 0) { config = {}; }
            this.config = Object.assign(Object.assign({}, DEFAULT_CONFIG), config);
        };
        VectorMapComponent.prototype.setStyle = function (style) {
            if (style === void 0) { style = {}; }
            this.style = Object.assign(Object.assign({}, DEFAULT_STYLE), style);
        };
        VectorMapComponent.prototype.setView = function () {
            this.viewId = this.dataSource instanceof Array ? null : this.dataSource.views[0].id;
            if (this.viewId) {
                this.viewChange = this.viewChange || new core.EventEmitter();
                this.views = this.dataSource.views;
            }
            else {
                this.views = null;
            }
        };
        VectorMapComponent.prototype.setPlotData = function () {
            var data = this.getData();
            this.max = Math.max.apply(Math, __spread([0], data.map(function (_b) {
                var value = _b.value;
                return value;
            })));
            this.setCountries(data);
            this.setLegend(this.paletteConfig.colorScale);
            this.data = [
                Object.assign(Object.assign({}, DEFAULT_DATA), { locations: this.countries.map(function (_b) {
                        var code = _b.code;
                        return code;
                    }), z: this.countries.map(function (_b) {
                        var value = _b.value;
                        return value;
                    }), text: this.countries.map(function (_b) {
                        var name = _b.name;
                        return name;
                    }), colorscale: this.paletteConfig.colorScale, marker: {
                        line: {
                            color: this.paletteConfig.vectorMap.marker.line.color,
                            width: this.paletteConfig.vectorMap.marker.line.width
                        }
                    }, zmax: this.max ? this.max : 1 })
            ];
        };
        VectorMapComponent.prototype.setCountries = function (data) {
            this.countries = COUNTRIES.map(function (country) {
                var countryData = data.find(function (_b) {
                    var name = _b.name, code = _b.code;
                    return name === country.name || code === country.code;
                }) || country;
                return Object.assign(Object.assign({}, country), { value: countryData ? countryData.value || 0 : 0 });
            });
        };
        VectorMapComponent.prototype.setLegend = function (colorScale) {
            var _this = this;
            this.legend.length = 0;
            colorScale.forEach(function (color, i, arr) {
                if (i === 0)
                    return;
                var text, v, v1, v2;
                switch (color[0]) {
                    case 0.1:
                        v = _this.getLegendValue(color[0], _this.max);
                        text = ">= " + v;
                        break;
                    case 1:
                        v = _this.getLegendValue(arr[i - 1][0], _this.max);
                        text = "< " + v;
                        break;
                    default:
                        v1 = _this.getLegendValue(color[0], _this.max);
                        v2 = _this.getLegendValue(arr[i - 1][0], _this.max) - 1;
                        text = v1 + " \u2014 " + v2;
                }
                _this.legend.push({
                    color: color[1].toString(),
                    text: text
                });
            });
        };
        VectorMapComponent.prototype.onHover = function (_b) {
            var _c = __read(_b.points, 1), point = _c[0];
            var box = document.querySelectorAll('.choroplethlocation')[point.pointIndex].getBBox();
            this.tooltipLeft = box.x + this.plot.plotEl.nativeElement.offsetLeft + box.width / 2 + 'px';
            this.tooltipTop = box.y + this.plot.plotEl.nativeElement.offsetTop + box.height / 2 + 'px';
            this.tooltip.message = point.text + ": " + point.z;
            this.tooltip.show(200);
        };
        VectorMapComponent.prototype.onUnHover = function () {
            this.tooltip.hide(200);
        };
        VectorMapComponent.prototype.onPlotClick = function (_b) {
            var _c = __read(_b.points, 1), point = _c[0];
            var clickedCountry = this.countries[point.pointIndex];
            this.click.emit(this.getData().find(function (_b) {
                var name = _b.name, code = _b.code;
                return name === clickedCountry.name || code === clickedCountry.code;
            }));
        };
        VectorMapComponent.prototype.onViewChange = function ($event) {
            this.viewId = $event.value;
            this.setPlotData();
            this.plot.revision++;
            this.viewChange.emit(this.dataSource.views[$event.value]);
        };
        return VectorMapComponent;
    }());
    VectorMapComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-vector-map',
                    template: "<div class=\"vector-map\" fxLayout=\"column\">\n  <h3 class=\"uxg-h3\">{{ title }}</h3>\n  <div fxFlex=\"fill\" class=\"wrapper\" fxLayout=\"row\" fxLayout.xs=\"column\" #wrapper>\n    <div class=\"map\" fxFlex=\"fill\" #map>\n      <plotly-plot\n        *ngIf=\"plotlyReady$ | async\"\n        [data]=\"data\"\n        [layout]=\"layout\"\n        [config]=\"config\"\n        [style]=\"style\"\n        [useResizeHandler]=\"true\"\n        (hover)=\"onHover($event)\"\n        (unhover)=\"onUnHover()\"\n        (plotly_click)=\"onPlotClick($event)\"\n      >\n      </plotly-plot>\n    </div>\n    <div class=\"meta\" *ngIf=\"views || (max > 0 && showLegend === true)\">\n      <div class=\"meta-wrapper\" fxLayout=\"column\" fxLayoutAlign=\"center space-between\">\n        <div class=\"views\" *ngIf=\"views\">\n          <mat-form-field>\n            <mat-label>View by</mat-label>\n            <mat-select (selectionChange)=\"onViewChange($event)\" [value]=\"views[0]?.id\">\n              <mat-option *ngFor=\"let view of views\" [value]=\"view.id\">\n                {{ view.text }}\n              </mat-option>\n            </mat-select>\n          </mat-form-field>\n        </div>\n        <div class=\"legend\" *ngIf=\"max > 0 && showLegend === true\">\n          <ol>\n            <li *ngFor=\"let item of legend\">\n              <span class=\"color\" [ngStyle]=\"{ background: item.color }\"></span>\n              <span class=\"text uxg-body-3\">{{ item.text }}</span>\n            </li>\n          </ol>\n        </div>\n      </div>\n    </div>\n  </div>\n  <div\n    class=\"tooltip-parent\"\n    [ngStyle]=\"{ top: tooltipTop, left: tooltipLeft }\"\n    #tooltip=\"matTooltip\"\n    matTooltip=\"Text\"\n    matTooltipPosition=\"above\"\n  ></div>\n</div>\n",
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}.vector-map{display:block;position:relative;height:100%;padding:16px}.map,.wrapper{height:100%}.meta-wrapper{display:inline-block;padding-left:16px;height:100%}.legend{margin-top:auto;margin-left:auto}.legend li,.legend ol{margin:0;padding:0}.legend ol{list-style:none}.legend li{position:relative;white-space:nowrap;display:flex}@media only screen and (max-width:599px){.legend li{display:inline-flex;margin-right:16px}}.legend .color{border-radius:50%;display:inline-block;width:10px;height:10px;margin-top:4px}.legend .text{display:inline-block;margin-left:8px}.tooltip-parent{position:absolute}"]
                },] }
    ];
    /** @nocollapse */
    VectorMapComponent.ctorParameters = function () { return [
        { type: core$1.PaletteService },
        { type: core$1.LazyloadScriptService }
    ]; };
    VectorMapComponent.propDecorators = {
        plot: [{ type: core.ViewChild, args: [angularPlotly_js.PlotComponent, { static: false },] }],
        tooltip: [{ type: core.ViewChild, args: ['tooltip', { static: true },] }],
        title: [{ type: core.Input }],
        dataSource: [{ type: core.Input }],
        showLegend: [{ type: core.Input }],
        autoResize: [{ type: core.Input }],
        click: [{ type: core.Output }],
        viewChange: [{ type: core.Output }],
        onWindowResize: [{ type: core.HostListener, args: ['window:resize',] }]
    };

    var VectorMapModule = /** @class */ (function () {
        function VectorMapModule(lazyLoadScriptService) {
            lazyLoadScriptService.load('plotly.js', 'Plotly').subscribe(function (plotly) {
                angularPlotly_js.PlotlyService.setPlotly(plotly);
            });
        }
        return VectorMapModule;
    }());
    VectorMapModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        tooltip.MatTooltipModule,
                        flexLayout.FlexLayoutModule,
                        select.MatSelectModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        angularPlotly_js.PlotlyViaCDNModule
                    ],
                    declarations: [VectorMapComponent],
                    exports: [VectorMapComponent]
                },] }
    ];
    /** @nocollapse */
    VectorMapModule.ctorParameters = function () { return [
        { type: core$1.LazyloadScriptService }
    ]; };

    /**
     * Generated bundle index. Do not edit.
     */

    exports.COUNTRIES = COUNTRIES;
    exports.DEFAULT_CONFIG = DEFAULT_CONFIG;
    exports.DEFAULT_DATA = DEFAULT_DATA;
    exports.DEFAULT_LAYOUT = DEFAULT_LAYOUT;
    exports.DEFAULT_STYLE = DEFAULT_STYLE;
    exports.VectorMapComponent = VectorMapComponent;
    exports.VectorMapModule = VectorMapModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-vector-map.umd.js.map
