export declare type ChangeLog = ChangeLog.Release[];
export declare namespace ChangeLog {
    interface Release {
        version?: string;
        date?: string;
        changes: Change[];
        categories: string[];
    }
    interface Change {
        category: string;
        description: string;
        type: 'New' | 'Bugfix' | 'Deprecated' | 'Update';
    }
}
