import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { PaletteConfig } from './palette.models';
export declare class PaletteService implements OnDestroy {
    private config;
    paletteChange$: Observable<PaletteConfig>;
    private internalSubject;
    constructor(config: PaletteConfig);
    ngOnDestroy(): void;
    changePalette(newPaletteConfig: PaletteConfig): void;
}
