import { OnInit, OnDestroy, EventEmitter, TemplateRef, OnChanges, SimpleChanges } from '@angular/core';
import { NavigationNode } from '../../services/navigation.model';
import { Breadcrumb } from '@ffdc/uxg-angular-components/breadcrumb';
export declare class NavbarComponent implements OnInit, OnDestroy, OnChanges {
    breadcrumbs: Breadcrumb[];
    brandIcon: string | undefined;
    currentNode: NavigationNode;
    navbarAction: TemplateRef<any>;
    appName: string;
    menuClick: EventEmitter<void>;
    brandAction: EventEmitter<any>;
    nodeChosen: EventEmitter<NavigationNode>;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    onMenuClick(): void;
    private buildBreadCrumb;
}
