import { OnInit, OnDestroy, EventEmitter, TemplateRef } from '@angular/core';
import { NavigationNode } from './services/navigation.model';
import { Router } from '@angular/router';
import { ReplaySubject } from 'rxjs';
export declare class GlobalNavComponent implements OnInit, OnDestroy {
    private router;
    appName: string;
    navigationNodes: NavigationNode[];
    activeRoute: string;
    currentNode: NavigationNode;
    brandIcon: string | undefined;
    appContent: TemplateRef<any>;
    navbarAction: TemplateRef<any>;
    menuClick: EventEmitter<void>;
    brandAction: EventEmitter<any>;
    nodeChosen: EventEmitter<NavigationNode>;
    logout: EventEmitter<void>;
    currentRoute: ReplaySubject<string>;
    constructor(router: Router);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
