export interface NavigationNode {
    path?: string;
    title?: string;
    tooltip?: string;
    icon?: string;
    openInNewTab?: boolean;
}
/**
 *  view: 'SideNav' | 'TopBar' | 'Footer' | etc
 */
export interface NavigationViews {
    [view: string]: NavigationNode[];
}
export interface ParamMapBuilder {
    [key: string]: () => Promise<string>;
}
