import { TemplateRef, AfterContentInit } from '@angular/core';
import { DefaultGravatar, AvatarColor } from '@ffdc/uxg-angular-components/avatar';
import { UserProfile } from './user-profile';
import { HeaderType } from './user-profile-menu.component';
export declare class UxgUserProfilePanelComponent implements AfterContentInit {
    user: UserProfile;
    defaultGravatar: DefaultGravatar | undefined;
    color: AvatarColor;
    headerType: HeaderType;
    contentTemplate?: TemplateRef<any>;
    actionsTemplate?: TemplateRef<any>;
    detailsTemplate?: TemplateRef<any>;
    avatarImage: TemplateRef<any>;
    uxgUserProfilePanelContent: TemplateRef<any> | undefined;
    uxgUserProfilePanelActions: TemplateRef<any> | undefined;
    uxgUserProfilePanelDetails: TemplateRef<any> | undefined;
    hasContent: boolean;
    hasFooter: boolean;
    hasDetails: boolean;
    constructor();
    ngAfterContentInit(): void;
}
