import { QueryList } from '@angular/core';
import { UxgWizardPageComponent } from '../wizard-page/wizard-page.component';
export declare class PageCollectionService {
    pages?: QueryList<UxgWizardPageComponent>;
    get pagesAsArray(): UxgWizardPageComponent[];
    get pagesCount(): number;
    get lastPage(): UxgWizardPageComponent | null;
    get firstPage(): UxgWizardPageComponent | null;
    getPageById(id: string): UxgWizardPageComponent;
    getPageByIndex(index: number): UxgWizardPageComponent;
    getPageIndex(page: UxgWizardPageComponent | null): number;
    private checkResults;
    pageRange(start: number, end: number): UxgWizardPageComponent[];
    getPageRangeFromPages(page: UxgWizardPageComponent, otherPage: UxgWizardPageComponent): UxgWizardPageComponent[];
    getPreviousPage(page: UxgWizardPageComponent): UxgWizardPageComponent | null;
    getNextPage(page: UxgWizardPageComponent | null): UxgWizardPageComponent | null;
    constructor();
}
