(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/flex-layout'), require('@angular/forms'), require('@angular/material/expansion'), require('@angular/material/icon'), require('@angular/material/button'), require('@angular/material/divider'), require('@angular/material/badge'), require('@angular/material/chips'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/material/dialog'), require('@ffdc/uxg-angular-components/core')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/filter/filter-group', ['exports', '@angular/common', '@angular/core', '@angular/flex-layout', '@angular/forms', '@angular/material/expansion', '@angular/material/icon', '@angular/material/button', '@angular/material/divider', '@angular/material/badge', '@angular/material/chips', '@angular/material/form-field', '@angular/material/input', '@angular/material/dialog', '@ffdc/uxg-angular-components/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components'].filter = global.ffdc['uxg-angular-components'].filter || {}, global.ffdc['uxg-angular-components'].filter['filter-group'] = {}), global.ng.common, global.ng.core, global.ng.flexLayout, global.ng.forms, global.ng.material.expansion, global.ng.material.icon, global.ng.material.button, global.ng.material.divider, global.ng.material.badge, global.ng.material.chips, global.ng.material.formField, global.ng.material.input, global.ng.material.dialog, global.ffdc['uxg-angular-components'].core));
}(this, (function (exports, common, core, flexLayout, forms, expansion, icon, button, divider, badge, chips, formField, input, dialog, core$1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var FilterGroupDialogComponent = /** @class */ (function () {
        function FilterGroupDialogComponent(dialogRef, data) {
            this.dialogRef = dialogRef;
            this.data = data;
        }
        FilterGroupDialogComponent.prototype.onNoClick = function () {
            this.dialogRef.close();
        };
        FilterGroupDialogComponent.prototype.save = function () {
            if (!this.filterName.invalid)
                this.dialogRef.close(this.filterName.value);
        };
        FilterGroupDialogComponent.prototype.ngOnInit = function () {
            this.filterName = new forms.FormControl('', [forms.Validators.required, this.nameExistsValidator()]);
        };
        FilterGroupDialogComponent.prototype.nameExistsValidator = function () {
            var _this = this;
            return function (control) {
                return _this.data.existingNames.indexOf(control.value) >= 0 ? { nameExists: { value: control.value } } : null;
            };
        };
        FilterGroupDialogComponent.prototype.getErrorMessage = function () {
            return this.filterName.hasError('required')
                ? 'Name is required'
                : this.filterName.hasError('nameExists')
                    ? 'Name already exists'
                    : '';
        };
        return FilterGroupDialogComponent;
    }());
    FilterGroupDialogComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-filter-group-dialog',
                    template: "<div mat-dialog-content class=\"filter-group-dialog-header\">\n  <div class=\"dialog-title uxg-h6\">Name of Filter</div>\n</div>\n<div mat-dialog-content>\n  <mat-form-field class=\"filter-group-dialog-form\">\n    <input matInput placeholder=\"Name\" maxlength=\"10\" [formControl]=\"filterName\" />\n    <mat-error *ngIf=\"filterName.invalid\">{{ getErrorMessage() }}</mat-error>\n  </mat-form-field>\n</div>\n<div mat-dialog-actions class=\"filter-group-dialog-actions\">\n  <button mat-stroked-button color=\"accent\" (click)=\"save()\">Save</button>\n</div>\n",
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}.filter-group-dialog-header{position:relative;top:-24px}.filter-group-dialog-header .dialog-title{margin-top:16px}.filter-group-dialog-form{width:100%}.filter-group-dialog-actions.mat-dialog-actions{display:flex;justify-content:center}"]
                },] }
    ];
    /** @nocollapse */
    FilterGroupDialogComponent.ctorParameters = function () { return [
        { type: dialog.MatDialogRef },
        { type: undefined, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] }
    ]; };

    var UxgFilter = /** @class */ (function () {
        function UxgFilter(ref) {
            this.ref = ref;
            this.instance = '';
        }
        UxgFilter.prototype.ngAfterViewInit = function () {
            this.component = this.ref.nativeElement.__component;
        };
        return UxgFilter;
    }());
    UxgFilter.decorators = [
        { type: core.Directive, args: [{ selector: '[uxgFilter]' },] }
    ];
    /** @nocollapse */
    UxgFilter.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    UxgFilter.propDecorators = {
        instance: [{ type: core.Input, args: ['uxgFilter',] }]
    };

    var FilterGroupComponent = /** @class */ (function () {
        function FilterGroupComponent(dialog, cd) {
            this.dialog = dialog;
            this.cd = cd;
            this.changes = new core.EventEmitter();
            this.expanded = false;
            this.divideAtIndex = [];
            this.showActions = false;
            this.autoApply = false;
            this.subscriptions = [];
            this.selectedData = [];
            this.savedFilters = [];
            this.existingFilterNames = [];
            this.initialState = [];
            this.activeFilter = [];
            this.isActive = false;
            this.headerHeight = '40px';
        }
        FilterGroupComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.filterInstances.forEach(function (filterInstance) {
                var instanceTitle = filterInstance.instance;
                var selected = {};
                selected[instanceTitle] = filterInstance.component.getState();
                _this.selectedData.push({ title: instanceTitle, selectedData: __spread(selected[instanceTitle]) });
                _this.initialState.push({ title: instanceTitle, selectedData: __spread(selected[instanceTitle]) });
                _this.subscriptions.push(filterInstance.component.changes.subscribe(function (change) {
                    change.instance = instanceTitle;
                    _this.selectedData.forEach(function (filter) {
                        if (filter.title === change.instance) {
                            filter.selectedData = filterInstance.component.getState();
                        }
                    });
                    _this.changes.emit(change);
                    if (_this.autoApply) {
                        _this.applyFilters();
                    }
                }));
            });
            setTimeout(function () { return _this.applyFilters(); });
        };
        FilterGroupComponent.prototype.ngOnDestroy = function () {
            this.subscriptions.forEach(function (s) { return s.unsubscribe(); });
        };
        FilterGroupComponent.prototype.openDialog = function () {
            var _this = this;
            var dialogConfig = new dialog.MatDialogConfig();
            dialogConfig.width = '300px';
            dialogConfig.data = {
                existingNames: this.existingFilterNames
            };
            this.dialogRef = this.dialog.open(FilterGroupDialogComponent, dialogConfig);
            var state = this.getFilterStates();
            this.dialogRef.afterClosed().subscribe(function (result) {
                if (result) {
                    _this.savedFilters.forEach(function (filter) {
                        filter.isSelected = false;
                    });
                    _this.existingFilterNames.push(result.trim());
                    _this.savedFilters.push({
                        filterName: result.trim(),
                        filterState: state,
                        isSelected: true
                    });
                }
                _this.dialogRef = undefined;
                _this.cd.markForCheck();
            });
        };
        FilterGroupComponent.prototype.selectFilter = function (filter) {
            this.savedFilters.forEach(function (savedFilter) {
                if (savedFilter.filterName === filter.filterName) {
                    savedFilter.isSelected = true;
                }
                else {
                    savedFilter.isSelected = false;
                }
            });
            this.setState(filter.filterState);
        };
        FilterGroupComponent.prototype.applyFilters = function () {
            var _this = this;
            var change;
            var activeFilter = [];
            this.filterInstances.forEach(function (filterInstance) {
                var data = filterInstance.component.getState();
                activeFilter.push({ title: filterInstance.instance, selectedData: data });
                change = {
                    instance: filterInstance.instance,
                    added: data,
                    removed: []
                };
                _this.changes.emit(change);
            });
            this.activeFilter = activeFilter;
            this.isActive = this.checkIsActive();
        };
        FilterGroupComponent.prototype.updateFilter = function () {
            var state = this.getFilterStates();
            this.savedFilters.forEach(function (filter) {
                if (filter.isSelected) {
                    filter.filterState = state;
                }
            });
        };
        FilterGroupComponent.prototype.removeFilter = function (filter) {
            this.savedFilters = this.savedFilters.filter(function (item) { return item !== filter; });
            this.existingFilterNames = this.existingFilterNames.filter(function (items) { return items !== filter.filterName; });
        };
        FilterGroupComponent.prototype.clearSelection = function () {
            this.filterInstances.forEach(function (filterInstance) {
                filterInstance.component.clearSelection();
            });
            this.selectedData.forEach(function (instance) {
                instance.selectedData.length = 0;
            });
        };
        FilterGroupComponent.prototype.resetSelection = function () {
            this.setState(this.initialState);
        };
        FilterGroupComponent.prototype.getFilterStates = function () {
            var groupState = [];
            this.filterInstances.forEach(function (instance) {
                if (instance.component.getState) {
                    groupState.push({
                        title: instance.instance,
                        selectedData: instance.component.getState()
                    });
                }
            });
            return groupState;
        };
        FilterGroupComponent.prototype.getState = function () {
            return __spread(this.selectedData);
        };
        FilterGroupComponent.prototype.setState = function (data) {
            var _this = this;
            if (data.length) {
                this.filterInstances.forEach(function (filterInstance) {
                    for (var i = 0; i < data.length; i++) {
                        if (filterInstance.instance === data[i].title && filterInstance.component.setState) {
                            filterInstance.component.setState(data[i].selectedData);
                        }
                    }
                });
                data.forEach(function (obj) {
                    _this.selectedData.forEach(function (obj2) {
                        var _a;
                        if (obj.title === obj2.title) {
                            obj2.selectedData.length = 0;
                            (_a = obj2.selectedData).push.apply(_a, __spread(obj.selectedData));
                        }
                    });
                });
            }
        };
        FilterGroupComponent.prototype.open = function () {
            if (this.activeFilter.length) {
                this.setState(this.activeFilter);
                if (this.savedFilters.length) {
                    for (var i = 0; i < this.savedFilters.length; i++)
                        if (this.savedFilters[i].isSelected === true &&
                            !this.checkListEquality(this.savedFilters[i].filterState, this.activeFilter)) {
                            this.savedFilters[i].isSelected = false;
                            break;
                        }
                }
            }
            else if (this.savedFilters.length) {
                this.setState(this.getSelectedFilterState());
            }
        };
        FilterGroupComponent.prototype.close = function () {
            if (this.activeFilter.length) {
                this.setState(this.activeFilter);
            }
            else if (this.savedFilters.length) {
                this.setState(this.getSelectedFilterState());
            }
            else {
                this.resetSelection();
            }
        };
        FilterGroupComponent.prototype.getSelectedFilterState = function () {
            var stateArray = [];
            this.savedFilters.forEach(function (filter) {
                if (filter.isSelected) {
                    for (var key in filter.filterState) {
                        if (filter.filterState.hasOwnProperty(key))
                            stateArray.push(filter.filterState[key]);
                    }
                }
            });
            return stateArray;
        };
        FilterGroupComponent.prototype.checkIsActive = function () {
            if (this.selectedData.some(function (data) { return data.selectedData.length; }) &&
                this.activeFilter.some(function (data) { return data.selectedData.length; })) {
                return this.checkListEquality(this.activeFilter, this.selectedData);
            }
            return false;
        };
        FilterGroupComponent.prototype.checkListEquality = function (listA, listB) {
            for (var i = 0; i < listA.length; i++) {
                if (listA[i].title === listB[i].title && listA[i].selectedData.length === listB[i].selectedData.length) {
                    for (var j = 0; j < listA[i].selectedData.length; j++) {
                        if (listB[i].selectedData.indexOf(listA[i].selectedData[j]) === -1) {
                            return false;
                        }
                    }
                }
                else {
                    return false;
                }
            }
            return true;
        };
        FilterGroupComponent.prototype.checkDivider = function (index) {
            if (this.divideAtIndex.indexOf(index) >= 0) {
                return true;
            }
            else {
                return false;
            }
        };
        FilterGroupComponent.prototype.handleOutsideClick = function () {
            if (this.expansionPanel.expanded && !this.dialogRef) {
                this.expansionPanel.close();
            }
        };
        return FilterGroupComponent;
    }());
    FilterGroupComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-filter-group',
                    template: "<mat-expansion-panel\n  #filterGroupPanel\n  class=\"uxg-expansion-filter uxg-filter-group\"\n  hideToggle=\"true\"\n  [expanded]=\"expanded\"\n  [class.active]=\"isActive\"\n  (uxgClickOutside)=\"handleOutsideClick()\"\n>\n  <mat-expansion-panel-header\n    [expandedHeight]=\"headerHeight\"\n    [collapsedHeight]=\"headerHeight\"\n    (click)=\"$event.stopPropagation(); filterGroupPanel.expanded ? open() : close()\"\n  >\n    <div class=\"uxg-filter-group-header\">\n      <div class=\"selectedFilters\">\n        <ng-container *ngFor=\"let filter of selectedData; let i = index\">\n          <div\n            *ngIf=\"filter.selectedData.length && !filter.selectedData[0].value\"\n            matBadge=\"{{ filter.selectedData.length }}\"\n            class=\"uxg-group-filter uxg-side-badge\"\n          >\n            {{ filter.title }}\n          </div>\n          <div *ngIf=\"!filter.selectedData.length\" matBadge=\"All\" class=\"uxg-group-filter uxg-side-badge\">\n            {{ filter.title }}\n          </div>\n          <div\n            *ngIf=\"filter.selectedData.length && filter.selectedData[0].value\"\n            class=\"uxg-group-filter uxg-side-badge\"\n          >\n            {{ filter.title }}<span class=\"filter-value\">{{ filter.selectedData[0].label }}</span>\n          </div>\n          <mat-divider *ngIf=\"checkDivider(i)\" class=\"filter-divider\" vertical></mat-divider>\n        </ng-container>\n      </div>\n      <span class=\"fill-remaining-space\"></span>\n      <div class=\"expand-button\">\n        <button mat-icon-button [color]=\"filterGroupPanel.expanded ? 'primary' : 'neutral'\">\n          <mat-icon>{{ filterGroupPanel.expanded ? 'arrow_drop_up' : 'arrow_drop_down' }}</mat-icon>\n        </button>\n      </div>\n    </div>\n  </mat-expansion-panel-header>\n\n  <div class=\"expansion-panel-header\">\n    <h6 class=\"uxg-h6\">Filter by</h6>\n    <button mat-button color=\"accent\" dense (click)=\"clearSelection()\">\n      <mat-icon>refresh</mat-icon>\n      Reset\n    </button>\n  </div>\n\n  <ng-template matExpansionPanelContent>\n    <div class=\"expansion-panel-content\" fxLayout=\"row wrap\" fxLayoutAlign=\"start\">\n      <ng-content></ng-content>\n    </div>\n\n    <ng-container *ngIf=\"showActions\">\n      <mat-divider></mat-divider>\n      <div class=\"expansion-panel-actions\" fxLayout=\"row wrap\">\n        <div class=\"saved-filters-container\">\n          <mat-chip-list #savedFiltersList>\n            <mat-chip\n              *ngFor=\"let filter of savedFilters\"\n              large\n              removable\n              (click)=\"selectFilter(filter)\"\n              [selected]=\"filter.isSelected\"\n              (removed)=\"removeFilter(filter)\"\n            >\n              {{ filter.filterName }}\n              <mat-icon matChipRemove>cancel</mat-icon>\n            </mat-chip>\n          </mat-chip-list>\n        </div>\n\n        <button *ngIf=\"savedFilters.length\" mat-button color=\"accent\" (click)=\"updateFilter()\">Update</button>\n        <button *ngIf=\"savedFilters.length\" mat-button color=\"accent\" (click)=\"clearSelection()\">Clear</button>\n        <mat-divider vertical=\"true\"></mat-divider>\n        <button mat-stroked-button color=\"accent\" (click)=\"openDialog()\">Save as</button>\n        <button mat-stroked-button color=\"accent\" (click)=\"filterGroupPanel.toggle(); close()\">Cancel</button>\n        <button mat-flat-button color=\"accent\" (click)=\"applyFilters()\">Apply</button>\n      </div>\n    </ng-container>\n  </ng-template>\n</mat-expansion-panel>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}.uxg-expansion-filter .filter-value{padding:0 8px}.uxg-expansion-filter .mat-expansion-panel-header{border-width:1px;border-style:solid;cursor:default!important;padding-right:0}.uxg-expansion-filter .mat-expansion-panel-header .uxg-filter-group-header{width:100%;display:flex;align-items:center;cursor:default}.uxg-expansion-filter .mat-expansion-panel-header .uxg-filter-group-header .fill-remaining-space{flex:1 1 auto}.uxg-expansion-filter .mat-expansion-panel-header .uxg-filter-group-header .selectedFilters{overflow:hidden;display:flex}.uxg-expansion-filter .mat-expansion-panel-header .uxg-filter-group-header .selectedFilters .uxg-group-filter{flex:0 0 auto;margin-right:24px}.uxg-expansion-filter .mat-expansion-panel-header .uxg-filter-group-header .selectedFilters .filter-divider{margin-right:24px}.uxg-expansion-filter .mat-expansion-panel-header .uxg-filter-group-header .selectedFilters .mat-standard-chip{cursor:pointer}.expansion-panel-header{display:flex;padding:8px 24px;box-sizing:border-box;justify-content:space-between;border-top-left-radius:4px;border-top-right-radius:4px}.expansion-panel-header .uxg-h6{align-self:center;margin-bottom:0}.expansion-panel-content{padding:24px}.expansion-panel-actions{padding:16px;align-items:center}.expansion-panel-actions .saved-filters-container{flex:1}.expansion-panel-actions .saved-filters-container .mat-chip{cursor:pointer}.expansion-panel-actions .mat-button-base{margin-left:16px}"]
                },] }
    ];
    /** @nocollapse */
    FilterGroupComponent.ctorParameters = function () { return [
        { type: dialog.MatDialog },
        { type: core.ChangeDetectorRef }
    ]; };
    FilterGroupComponent.propDecorators = {
        changes: [{ type: core.Output }],
        filterInstances: [{ type: core.ContentChildren, args: [UxgFilter, { descendants: true },] }],
        expansionPanel: [{ type: core.ViewChild, args: [expansion.MatExpansionPanel,] }],
        expanded: [{ type: core.Input }],
        divideAtIndex: [{ type: core.Input }],
        showActions: [{ type: core.Input }],
        autoApply: [{ type: core.Input }]
    };

    var FilterGroupModule = /** @class */ (function () {
        function FilterGroupModule() {
        }
        return FilterGroupModule;
    }());
    FilterGroupModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [FilterGroupComponent, UxgFilter, FilterGroupDialogComponent],
                    imports: [
                        forms.ReactiveFormsModule,
                        common.CommonModule,
                        expansion.MatExpansionModule,
                        icon.MatIconModule,
                        button.MatButtonModule,
                        divider.MatDividerModule,
                        badge.MatBadgeModule,
                        chips.MatChipsModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        flexLayout.FlexLayoutModule,
                        dialog.MatDialogModule,
                        forms.FormsModule,
                        core$1.ClickOutsideModule
                    ],
                    entryComponents: [FilterGroupDialogComponent],
                    exports: [FilterGroupComponent, UxgFilter]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.FilterGroupComponent = FilterGroupComponent;
    exports.FilterGroupModule = FilterGroupModule;
    exports.ɵa = UxgFilter;
    exports.ɵb = FilterGroupDialogComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-filter-filter-group.umd.js.map
