export declare const CHART_DEFAULT_PLOTLY_LAYOUT: {
    autosize: boolean;
    margin: {
        l: number;
        r: number;
        b: number;
        t: number;
        pad: number;
    };
};
export declare const CHART_DEFAULT_PLOTLY_CONFIG: {
    displaylogo: boolean;
    responsive: boolean;
};
export declare enum ChartType {
    bar = "bar",
    stackedBar = "stackedBar",
    line = "line",
    scatter = "scatter",
    scatterLine = "scatterLine",
    stackedLine = "stackedLine",
    fullStackedLine = "fullStackedLine",
    spline = "spline",
    stackedSpline = "stackedSpline",
    fullStackedSpline = "fullStackedSpline",
    stepline = "stepline",
    steparea = "steparea",
    area = "area",
    stackedArea = "stackedArea",
    fullStackedArea = "fullStackedArea",
    pie = "pie",
    donut = "donut"
}
export declare enum ChartOrientation {
    horizontal = "horizontal",
    vertical = "vertical"
}
export interface ChartTypeConvertion {
    name: string;
    group: string;
    trace: any;
    layout?: any;
}
export declare const CHART_PLOLTLY_TYPE: Record<ChartType, ChartTypeConvertion>;
