import { EventEmitter, OnInit, SimpleChanges, OnChanges } from '@angular/core';
export interface EntityMenuItemWEvent {
    value: any;
    $event: MouseEvent;
}
export declare class EntityMenuComponent implements OnInit, OnChanges {
    items: any[];
    data: Array<any>;
    title: string;
    property?: string;
    abbreviationLength: number;
    itemClick: EventEmitter<EntityMenuItemWEvent>;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onItemClick(value: any, $event: MouseEvent): void;
    private mapData;
    formatItemName(name: string): string;
}
export declare class EntityMenuActionsComponent {
}
