import { OnInit } from '@angular/core';
import { FormControl, ValidatorFn } from '@angular/forms';
import { MatDialogRef } from '@angular/material/dialog';
export interface FilterGroupDialogData {
    existingNames: string[];
}
export declare class FilterGroupDialogComponent implements OnInit {
    dialogRef: MatDialogRef<FilterGroupDialogComponent>;
    data: FilterGroupDialogData;
    filterName: FormControl;
    constructor(dialogRef: MatDialogRef<FilterGroupDialogComponent>, data: FilterGroupDialogData);
    onNoClick(): void;
    save(): void;
    ngOnInit(): void;
    nameExistsValidator(): ValidatorFn;
    getErrorMessage(): "" | "Name is required" | "Name already exists";
}
