import { ElementRef, EventEmitter } from '@angular/core';
export interface MultiselectTag {
    label: string;
    isSelected?: boolean;
}
interface UXGMultiSelectFilterChanges {
    added: MultiselectTag[];
    removed: MultiselectTag[];
}
export declare class MultiselectTagsComponent {
    private hostElement;
    private _data;
    dense: null;
    large: null;
    set data(data: MultiselectTag[]);
    get data(): MultiselectTag[];
    changes: EventEmitter<UXGMultiSelectFilterChanges>;
    constructor(hostElement: ElementRef);
    onTagSelection(tag: MultiselectTag): void;
    removeFocusFromChip(): void;
    add(tag: MultiselectTag): void;
    remove(tag: MultiselectTag): void;
    clearSelection(): void;
    getState(): MultiselectTag[];
    setState(data: MultiselectTag[]): void;
}
export {};
