import { OnInit, OnChanges, ChangeDetectorRef, SimpleChanges } from '@angular/core';
import { MatSidenav } from '@angular/material/sidenav';
import { NavigationNode } from '../../services/navigation.model';
import { EventEmitter } from '@angular/core';
export declare class SidenavComponent implements OnInit, OnChanges {
    private _host;
    private cd;
    appName: string;
    navigationNodes: NavigationNode[];
    activeRoute: string;
    logout: EventEmitter<void>;
    nodeChosen: EventEmitter<NavigationNode>;
    currentNodes: NavigationNode[];
    iconName: string;
    constructor(_host: MatSidenav, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private getIconName;
    onClick(node: NavigationNode): void;
    isActive(path: string): boolean | undefined;
}
