import { Overlay } from '@angular/cdk/overlay';
import { PortalInjector } from '@angular/cdk/portal';
import { ComponentRef, Injector } from '@angular/core';
import { SearchConfig } from '../components/global-search-overlay/global-search-overlay-config';
import { SearchOverlayRef } from '../components/global-search-overlay/global-search-overlay-ref';
import { GlobalSearchOverlayComponent } from '../components/global-search-overlay/global-search-overlay.component';
export declare type GlobalSearchOverlay = [SearchOverlayRef, ComponentRef<GlobalSearchOverlayComponent>];
export declare class GlobalSearchOverlayService {
    private overlay;
    private parentInjector;
    constructor(overlay: Overlay, parentInjector: Injector);
    open(config?: SearchConfig): GlobalSearchOverlay;
    getInjector(config: SearchConfig, overlayRef: SearchOverlayRef, parentInjector: Injector): PortalInjector;
}
