import { OnInit, ComponentFactory, Type, ComponentFactoryResolver, SimpleChanges, OnChanges, EventEmitter } from '@angular/core';
export declare class RepeaterComponent implements OnInit, OnChanges {
    private resolver;
    private _data;
    get data(): Array<any>;
    set data(data: Array<any>);
    component: Type<any> | ComponentFactory<any>;
    orientation: string;
    multiSelect: boolean;
    space: string;
    columnsMatcher: {
        [k: string]: string;
    };
    selectedKeys: number[];
    selectionChange: EventEmitter<any>;
    selectedItems: {
        [k: string]: any;
    };
    componentFactory?: ComponentFactory<any>;
    constructor(resolver: ComponentFactoryResolver);
    ngOnInit(): void;
    onClick(index: number, value: any): void;
    isSelected(index: number): boolean;
    ngOnChanges(changes: SimpleChanges): void;
}
