import { ToasterConfig } from './toaster.config';
export declare class Toast {
    message: string;
    config: ToasterConfig;
}
export declare enum ToastType {
    SUCCESS = "success",
    ERROR = "error",
    WARNING = "warning",
    INFO = "info"
}
export declare enum ToastLogicalPosition {
    TOP_START = "top-start",
    TOP_END = "top-end",
    BOTTOM_START = "bottom-start",
    BOTTOM_END = "bottom-end"
}
export declare enum ToastPhysicalPosition {
    TOP_RIGHT = "top-right",
    TOP_LEFT = "top-left",
    BOTTOM_RIGHT = "bottom-right",
    BOTTOM_LEFT = "bottom-left"
}
export declare type ToastPosition = ToastPhysicalPosition | ToastLogicalPosition;
