import { TemplateRef } from '@angular/core';
import { UserProfile } from './user-profile';
import { DefaultGravatar, AvatarColor } from '@ffdc/uxg-angular-components/avatar';
import { MatMenuTrigger } from '@angular/material/menu';
export declare type HeaderType = 'hero' | 'title';
export declare class UxgUserProfileMenuComponent {
    dense: any;
    user: UserProfile;
    defaultGravatar: DefaultGravatar | undefined;
    color: AvatarColor;
    headerType: HeaderType;
    avatarImage: TemplateRef<any>;
    userMenuTrigger: MatMenuTrigger;
    uxgUserProfilePanelContent: TemplateRef<any> | undefined;
    uxgUserProfilePanelActions: TemplateRef<any> | undefined;
    uxgUserProfilePanelDetails: TemplateRef<any> | undefined;
    constructor(dense: any);
}
