import { EventEmitter, TemplateRef } from '@angular/core';
import { ButtonHubService } from '../services/button-hub.service';
import { PageCollectionService } from '../services/page-collection.service';
import { WizardNavigationService } from '../services/wizard-navigation.service';
import { UxgWizardPageDescriptionComponent } from './wizard-page-description.directive';
import { UxgWizardPageTitleComponent } from './wizard-page-title.directive';
export declare class UxgWizardPageComponent {
    private navService;
    pageCollection: PageCollectionService;
    buttonService: ButtonHubService;
    load: EventEmitter<string>;
    nextButtonClicked: EventEmitter<UxgWizardPageComponent>;
    previousButtonClicked: EventEmitter<UxgWizardPageComponent>;
    doneButtonClicked: EventEmitter<UxgWizardPageComponent>;
    get id(): string;
    get current(): boolean;
    constructor(navService: WizardNavigationService, pageCollection: PageCollectionService, buttonService: ButtonHubService);
    pageTitle: UxgWizardPageTitleComponent;
    pageDescription: UxgWizardPageDescriptionComponent;
    private _disabled;
    get disabled(): boolean;
    set disabled(val: boolean);
    pageDisabledChange: EventEmitter<boolean>;
    private _nextStepDisabled;
    get nextStepDisabled(): boolean;
    set nextStepDisabled(val: boolean);
    nextStepDisabledChange: EventEmitter<boolean>;
    private _previousStepDisabled;
    get previousStepDisabled(): boolean;
    set previousStepDisabled(val: boolean);
    previousStepDisabledChange: EventEmitter<boolean>;
    get title(): TemplateRef<any>;
    get description(): TemplateRef<any>;
    private _showTitle;
    get showTitle(): boolean;
    set showTitle(val: boolean);
}
